import  java.io.*;
import  java.util.Scanner;

class vertex {
    int color;
    int start, end;
    int pred;
    int dist;
    List adj;
}


public class Graph {

    private static boolean isDag = true;
    private static int INF = 1000;
    private static int NIL = -1;
    private static int WHITE = 0;
    private static int GREY = 1;
    private static int BLACK = 2;
    private static int time = 0;

    private static Stack ST;

    static String colorname [] = {"W","G","B"};

    private static vertex [] nodes;
    private static int size;

    public static void init(int n) {
	size = n;
        nodes = new vertex[size];
        for (int i = 0;i<size;i++) {
            nodes[i] = new vertex();
	    nodes[i].adj = new List();
	    nodes[i].adj.init(size);
	}
	reset();
    }

    public static void reset() {
        time=0;
        isDag=true;
        for (int i = 0;i<size;i++) {
	    nodes[i].color = WHITE;
            nodes[i].start=nodes[i].end=-1;
            nodes[i].pred=NIL;
            nodes[i].dist=INF;
	}
    }


    public static void print() {
      System.out.printf("\n--------- Graph: -------\n");
      for  (int i = 0;i<size;i++) {
	  System.out.printf("[%2d, %2d, %2d, %s,(%2d/%2d)]",
			      i,
                              nodes[i].pred,
                              nodes[i].dist,
                              colorname[nodes[i].color],
	                      nodes[i].start,
                              nodes[i].end);
          if (!nodes[i].adj.isEmpty()) nodes[i].adj.print();
          else System.out.printf("\n");
      }
      System.out.printf("------------------------\n");
    }

    public static void addEdge(int i,int j) {
	nodes[i].adj.insert(j);
    }

    public static void BFS(int s) {
        int u;
        Queue Q = new Queue ();
        Q.init();
        reset();
	nodes[s].color = GREY; 
	nodes[s].dist = 0; 
        Q.enqueue(s);
System.err.printf("Initially the queque is: ");Q.print();
        while (!Q.isEmpty()) {
	   u = Q.dequeue();
System.err.printf("Visiting %d ... ",u); 
           for (int i=0;i<nodes[u].adj.count;i++) {
               int v = nodes[u].adj.value(i);
	       if (nodes[v].color == WHITE) {
		   nodes[v].color = GREY;
                   nodes[v].pred = u;
                   nodes[v].dist = nodes[u].dist+1;
                   Q.enqueue(v);
	       }
  	   }
System.err.printf("after visiting %d the queque is: ",u);Q.print();
           nodes[u].color = BLACK;
	}
    }

    public static void DFS(int s) {
        int u;
        Stack S = new Stack ();
        S.init();
        reset();
	nodes[s].color = GREY; 
	nodes[s].dist = 0; 
        S.push(s);
System.err.printf("Initially the stack is: ");S.print();
        while (!S.isEmpty()) {
	   u = S.pop();
System.err.printf("Visiting %d ... ",u); 
           for (int i=0;i<nodes[u].adj.count;i++) {
               int v = nodes[u].adj.value(i);
	       if (nodes[v].color == WHITE) {
		   nodes[v].color = GREY;
                   nodes[v].pred = u;
                   nodes[v].dist = nodes[u].dist+1;
                   S.push(v);
	       }
  	   }
System.err.printf("after visiting %d the stack is: ",u);S.print();
           nodes[u].color = BLACK;
	}
    }


    public static void allDFS() {
        reset();
	for (int i = 0;i<size;i++) {
	    if (nodes[i].color == WHITE) {
                recDFS(i);
	    }
	}
    }

    public static void recDFS(int u) {
System.err.printf("Invoking recDFS on %d \n",u);
	nodes[u].color = GREY; 
        time++;nodes[u].start=time;
        for (int i=0;i<nodes[u].adj.count;i++) {
            int v = nodes[u].adj.value(i);
// System.err.printf("    v = %d, v.color = %d \n",v,nodes[v].color);
	    if (nodes[v].color == WHITE) {
                nodes[v].pred = u;
                recDFS(v);
	    }
	}
        nodes[u].color = BLACK;
        time++;nodes[u].end=time;
    }


    public static boolean topologicalSorting() {
        isDag = true;
	reset();
        ST = new Stack();
        ST.init();
	for (int i = 0;i<size;i++) {
	    if (nodes[i].color == WHITE) {
                topSort(i);
	    }
	}
	if (isDag) {
          System.out.printf("Topological Sorting: "); 
          ST.revPrint();
	}
        else {
	    System.out.printf("!!! The graph is not a DAG, Topological Sorting is not possible!!!\n");
	}
    return isDag;
    }
        


    public static void topSort(int u) {
System.err.printf("Invoking recDFS on %d \n",u);
	nodes[u].color = GREY; 
        time++;
        nodes[u].start=time;
        for (int i=0;i<nodes[u].adj.count;i++) {
            int v = nodes[u].adj.value(i);
// System.err.printf("    v = %d, v.color = %d \n",v,nodes[v].color);
            if (nodes[v].color == GREY)
		isDag = false;
	    if (nodes[v].color == WHITE) {
                nodes[v].pred = u;
                topSort(v);
	    }
	}
        nodes[u].color = BLACK;
        time++;
        nodes[u].end=time;
        ST.push(u);
    }


}
